# SuccessFactors Connector #

## Demo ##

### Introduction ###

This demo shows how to set up the SuccessFactors Connector to interact with the SFAPI exposed by SuccessFactors. It will let you make basic calls to fetch the metadata of the entities available in your organization, as well as create, query, update and delete entities.

### How to run this demo ###

#### Prerequisites ####
In order to run this demo project you will need:

* Anypoint Studio with Mule ESB 3.7 EE Runtime or greater.
* SuccessFactors Connector v2.0.0.
* A SuccessFactors account.

#### Test the flows ####

With Anypoint Studio up and running, open the Import wizard from the File menu. A pop-up wizard will offer you the chance to pick Anypoint Studio Project from External Location. On the next wizard window point Project Root to the location of the demo project and select the Server Runtime as Mule Server 3.7.0 EE. Once successfully imported the studio will automatically present the Mule Flows.

From the Package Explorer view, expand the demo project and open the mule-app.properties file. Fill it in with your credentials as follows:

```
username=<username>
password=<password>
companyId=<company ID>
wsdlLocation=<location of the WSDL corresponding to your account>
```

Run the demo project and open the following URL with a browser: **http://localhost:8081**. You should see a page with various sections, each corresponding to a SFAPI operation.

#### Flows information ####

**htmlFormFlow :** Its purpose is to serve the form.html file.

**listEntitiesFlow :** Retrieves the list of entities in your organization.

**describeEntitiesFlow :** Retrieves the metadata from an entity in your organization.

**queryFlow :** Runs a query on Success Factors and shows the response. **queryNativeFlow** is functionally equivalent, but does not make use of the dynamic query builder.

**submitQueryFlow :** Submits a query for Success Factors to execute asynchronously and shows the response.

**getJobResultFlow :** Retrieves the result of a query previously submitted by **submitQueryFlow**.

**upsertFlow :** Inserts a new User (or updates it, if it already exists)

**updateFlow :** Updates an existing User.

**insertFlow :** Inserts a new Goal$1 entity and returns the output of the insertion.

**deleteFlow :** Deletes an existing Goal$1 entity and returns the output of the deletion.

